<?php
/**
 * Defines the Calendar page type
 */

class Calendar extends Page {
    static $allowed_children=array('CalendarEvent');

    function getCMSFields() {
        $fields = parent::getCMSFields();
        // ----
        // Renames existing fields
        // ----
        $fields->removeFieldFromTab('Root.Content.Main', 'Page name');
        $fields->addFieldToTab('Root.Content.Main', new TextField('Title', 'Name of the calender'));
        // ----
        // Removes a field
        // ----
        $fields->removeFieldFromTab('Root.Content.Main', 'Content');
        $fields->removeFieldFromTab('Root.Content.Main', 'MenuTitle');
        // ----
        return $fields;
    }

   /**
    * Add custom validation to the form
    *
    * @access public
    * @return RequiredFields
    */
   public function getCMSValidator() {
      return new RequiredFields('Title');
   }

    function returnValidCalendarID(){
        $user_id=Member::currentUserID();
        My::log($user_id,__LINE__);
        if(!empty($user_id)){
            $sql="select s.id as calendar_id from SiteTree s inner join SiteTree_versions stv on s.id=stv.recordid where stv.classname='Calendar' and stv.AuthorID=$user_id order by stv.version desc limit 1";
            My::log($sql,__LINE__);
            $row=My::returnRow($sql);
            if(!empty($row)){
                extract($row);
                return $calendar_id;
            }
        }
        return -1;
    }

    function createCalendarPopupsScript(){
        #My::log(BASE_PATH,__LINE__);
        #$dir=BASE_PATH."\\module_calendar\\javascript\\";
        $dir="../module_calendar/javascript/";
        #$dir="tttttttss";
        #My::log($dir,__LINE__);
        if(!file_exists($dir)){
            #My::log('before mkdir',__LINE__);
            mkdir($dir, 0777,true);
            #My::log('after mkdir',__LINE__);
        }
        $file=$dir.'popups.js';
        #My::log($file,__LINE__);
        @unlink($file);
        $sql="select id,st.title from CalendarEvent ce inner join SiteTree st using(ID)";
        $rows=My::returnRows($sql);
        foreach($rows as $row){
            extract($row);
            file_put_contents($file,"(function($) {\n",FILE_APPEND);
            file_put_contents($file,"$(document).ready(function () {\n",FILE_APPEND);
            file_put_contents($file,"var id='$id';\n",FILE_APPEND);
            file_put_contents($file,"var title='$title';\n",FILE_APPEND);
            file_put_contents($file,"$('#'+id).click(function () {\n",FILE_APPEND);
            file_put_contents($file,"showPopup(id,title);\n",FILE_APPEND);
            file_put_contents($file,"return false;\n",FILE_APPEND);
            file_put_contents($file,"});\n",FILE_APPEND);
            file_put_contents($file,"});\n",FILE_APPEND);
            file_put_contents($file,"})(jQuery);\n",FILE_APPEND);
            file_put_contents($file," \n",FILE_APPEND);
        }
    }

    function returnCalendarEvents(){
        My::log('in returnCalendarEvents',__LINE__);
        $sql="
        select s.ID,concat(substring(s.Title,1,30),'...') as Title,StartDate as sd,date_format(ce.StartDate,'%W, %D %M %Y') as StartDate,substring(StartTime,1,5) as StartTime,ce.EndDate,ce.EndTime,s2.URLSegment as calendar_url,s.URLSegment as event_url,s.Content from CalendarEvent ce inner join SiteTree s using(ID) inner join SiteTree s2 on s.ParentID=s2.ID where curdate()<=startdate order by sd asc,StartTime asc
        ";
        $rows=My::returnRows($sql);
        #$count=count($rows);
        #My::log("rows=$count",__LINE__);
        $object_set=new DataObjectSet();
        foreach($rows as $row) {
            $object_set->push(new ArrayData($row));
        }
        return $object_set;
    }

}

class Calendar_Controller extends Page_Controller {

}
