<?php
/**
 * Defines the CalendarEvent page type
 */

class CalendarEvent extends Page {

    // ----
    // Adds event to a calendar regardless of parent folder selected
    // ----
    function onBeforeWrite(){
        $id=Calendar::returnValidCalendarID();
        #My::log($id,__LINE__);
        if($id==-1)exit;
        $this->ParentID = $id;
        parent::onBeforeWrite();
    }

    static $db=array(
        'StartDate'=>'Date',
        'StartTime'=>'Text',
        'EndDate'=>'Date',
        'EndTime'=>'Text'
    );

    function getCMSFields() {
        $fields = parent::getCMSFields();
        // ----
        // Renames existing fields
        // ----
        $fields->removeFieldFromTab('Root.Content.Main', 'Page name');
        $fields->addFieldToTab('Root.Content.Main', new TextField('Title', 'Name of the event'));
        $fields->removeFieldFromTab('Root.Content.Main', 'Content');
        $fields->addFieldToTab("Root.Content.Main", new HTMLEditorField("Content", "Details of the event (e.g. venue)"));
        // ----
        // Removes a field
        // ----
        $fields->removeFieldFromTab('Root.Content.Main', 'MenuTitle');
        // ----
        // Adds new fields
        // ----
        $fields->addFieldToTab('Root.Content.Main', $dateField = new DateField('StartDate','Start date (Must be of the form 26/02/2013)'), 'Content');
        $dateField->setConfig('showcalendar', true);
        $dateField->setConfig('dateformat', 'dd/MM/YYYY');
        // ----
        $fields->addFieldToTab('Root.Content.Main', $timeField = new TimeField('StartTime','Start time'), 'Content');
        $timeField->setConfig('showdropdown', true);
        $timeField->setConfig('timeformat', 'h:m a');
        // ----
        $fields->addFieldToTab('Root.Content.Main', $dateField = new DateField('EndDate','Finish date (Must be of the form 26/02/2013)'), 'Content');
        $dateField->setConfig('showcalendar', true);
        $dateField->setConfig('dateformat', 'dd/MM/YYYY');
        // ----
        $fields->addFieldToTab('Root.Content.Main', $timeField = new TimeField('EndTime','Finish time'), 'Content');
        $timeField->setConfig('showdropdown', true);
        $timeField->setConfig('timeformat', 'h:m a');
        // ----
        return $fields;
    }

   /**
    * Add custom validation to the form
    *
    * @access public
    * @return RequiredFields
    */
    public function getCMSValidator() {
        #My::log($this,__LINE__);
        //* print debug */if(!isset($_SESSION)) session_start();$debug_excludes = array('debug_ip_list','debug_ip','debug_file','GLOBALS','_COOKIE','HTTP_SESSION_VARS','_REQUEST','HTTP_POST_FILES','HTTP_SERVER_VARS','_SERVER','HTTP_COOKIE_VARS','HTTP_GET_VARS','HTTP_POST_VARS','HTTP_ENV_VARS','_ENV','debug_excludes','debug_variables','debug_variables_name','debug_variables_web_pathname','debug_variables_file_pathname','debug_key','debug_value','debug_target_file');$debug_variable_array = array_values(array_diff(array_keys($GLOBALS), $debug_excludes));$temp = array();while (list($debug_key, $debug_value) = each($debug_variable_array)) {global $$debug_value;if(is_array($$debug_value))ksort($$debug_value);if($debug_value!='debug_variable_array')$temp[$debug_value] = $$debug_value;}ksort($temp);$debug_output=$temp;$local_variables=get_defined_vars();$keys = array_keys($local_variables);$key=array_search('debug_excludes', $keys);$slice = array_slice($local_variables, 0, $key);ksort($slice);$slice_sorted=array();foreach($slice as $key=>$value){if(is_array($value))ksort($value);$slice_sorted[$key]=$value;}ob_start();print "<pre>";print_r($slice_sorted);print "</pre>";$slice_variables=ob_get_clean();$line=__LINE__;$function=__FUNCTION__;if(!empty($function))echo "<b>Variables in function '$function' at Line $line</b><br/>$slice_variables";ob_start();print "<pre>";print_r($debug_output);print "</pre>";$debug_variables=ob_get_clean();$other_heading='';if(!empty($function))$other_heading="<b>Other variables</b><br/>";echo $other_heading.$debug_variables;unset($debug_output);unset($temp1);unset($temp2);unset($temp3);unset($debug_excludes);unset($debug_variables);unset($debug_variables_file);unset($debug_target_file);
        #return new RequiredFields('StartDate','StartTime','EndDate','EndTime','Title','Content');
        #Debug::show($this);
        return new RequiredFields();
    }

}

class CalendarEvent_Controller extends Page_Controller {
}
